package com.smartgwt.sample.client;

import java.util.HashMap;
import java.util.Map;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.i18n.client.NumberFormat;
import com.smartgwt.client.data.Criteria;
import com.smartgwt.client.data.DSCallback;
import com.smartgwt.client.data.DSRequest;
import com.smartgwt.client.data.DSResponse;
import com.smartgwt.client.data.DataSource;
import com.smartgwt.client.data.Record;
import com.smartgwt.client.rpc.LoginRequiredCallback;
import com.smartgwt.client.rpc.RPCCallback;
import com.smartgwt.client.rpc.RPCManager;
import com.smartgwt.client.rpc.RPCRequest;
import com.smartgwt.client.rpc.RPCResponse;
import com.smartgwt.client.types.Alignment;
import com.smartgwt.client.types.DragDataAction;  
import com.smartgwt.client.util.SC;
import com.smartgwt.client.widgets.Canvas;  
import com.smartgwt.client.widgets.IButton;
import com.smartgwt.client.widgets.Window;
import com.smartgwt.client.widgets.events.ClickEvent;
import com.smartgwt.client.widgets.events.DropEvent;
import com.smartgwt.client.widgets.events.DropHandler;
import com.smartgwt.client.widgets.form.DynamicForm;
import com.smartgwt.client.widgets.form.fields.ButtonItem;
import com.smartgwt.client.widgets.form.fields.PasswordItem;
import com.smartgwt.client.widgets.form.fields.TextItem;
import com.smartgwt.client.widgets.grid.CellFormatter;
import com.smartgwt.client.widgets.grid.ListGrid;  
import com.smartgwt.client.widgets.grid.ListGridRecord;
import com.smartgwt.client.widgets.layout.HLayout;
import com.smartgwt.client.widgets.layout.VLayout;
import com.smartgwt.client.widgets.tab.Tab;
import com.smartgwt.client.widgets.tab.TabSet;


/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class SecurityTomcat implements EntryPoint {

	private Window windowRelogin = new Window();
	private int lsmTransactionNum = -1;
    
	@Override
	public void onModuleLoad() {
		// TODO Auto-generated method stub
		Canvas canvas = new Canvas();  
		
		final DataSource usersDs = DataSource.get("users");
		final DataSource usersRolesDs = DataSource.get("usersRoles");
		final DataSource rolesDs = DataSource.get("roles");
		
	    final ListGrid usersRolesGrid = new ListGrid();  
		final ListGrid usersGrid = new ListGrid();  
	    final ListGrid rolesGrid = new ListGrid();
	    
	    usersRolesGrid.setWidth(300);
	    usersRolesGrid.setCanRemoveRecords(true);
	    usersRolesGrid.setHeight(224);
	    usersRolesGrid.setDataSource(usersRolesDs);
	    usersRolesGrid.setShowAllRecords(true);
	    usersRolesGrid.setCanReorderRecords(true);  
	    usersRolesGrid.setCanAcceptDroppedRecords(true);
	    usersRolesGrid.setAutoFetchData(false);
	    
	    usersGrid.setWidth(200);  
	    usersGrid.setHeight(224);  
	    usersGrid.setShowAllRecords(true);  
	    usersGrid.setCanReorderRecords(false);  
	    usersGrid.setCanAcceptDroppedRecords(false);
	    usersGrid.setDataSource(usersDs);
	    usersGrid.setAutoFetchData(true);
	    usersGrid.setPreventDuplicates(true);
	    usersGrid.addClickHandler(new com.smartgwt.client.widgets.events.ClickHandler(){

			@Override
			public void onClick(ClickEvent event) {
				// TODO Auto-generated method stub
				Criteria criteria = new Criteria();
				criteria.addCriteria("userName", usersGrid.getSelectedRecord().getAttributeAsString("userName"));
				usersRolesGrid.fetchData(criteria);
			}
	    });
	    
	    rolesGrid.setWidth(200);  
	    rolesGrid.setHeight(224);  
	    rolesGrid.setLeft(350);  
	    rolesGrid.setDataSource(rolesDs);
	    rolesGrid.setShowAllRecords(true);  
	    rolesGrid.setCanReorderFields(true);  
	    rolesGrid.setCanDragRecordsOut(true);  
	    rolesGrid.setCanAcceptDroppedRecords(false);  
	    rolesGrid.setDragDataAction(DragDataAction.COPY);  
	    rolesGrid.setAutoFetchData(true);

	    HLayout hLayout = new HLayout();
	    hLayout.setMargin(20);
	    hLayout.addMember(usersGrid);  
	    hLayout.addMember(usersRolesGrid);
	    hLayout.addMember(rolesGrid);

	    final DataSource ds = DataSource.get("supplyItem");

	    final ListGrid supplyItemGrid = new ListGrid();
	    supplyItemGrid.setWidth(700);  
	    supplyItemGrid.setHeight(250);  
        supplyItemGrid.setShowAllRecords(true);  
        supplyItemGrid.setDataSource(ds);  
        supplyItemGrid.setAutoFetchData(true);  
        supplyItemGrid.setCellFormatter(getFloatValuesFormatter());

        final DynamicForm supplyItemForm = new DynamicForm();
        supplyItemForm.setDataSource(ds);
        supplyItemForm.setWidth(700);
        supplyItemForm.setHeight(250);
        supplyItemForm.setNumCols(4);
        
        supplyItemGrid.addClickHandler(new com.smartgwt.client.widgets.events.ClickHandler(){

			@Override
			public void onClick(
					com.smartgwt.client.widgets.events.ClickEvent event) {
				// TODO Auto-generated method stub
				supplyItemForm.editRecord(supplyItemGrid.getSelectedRecord());
			}
        	
        });
        IButton saveButton = new IButton();
        saveButton.setTitle("Save");
        saveButton.addClickHandler(new com.smartgwt.client.widgets.events.ClickHandler(){

			@Override
			public void onClick(com.smartgwt.client.widgets.events.ClickEvent event) {
				// TODO Auto-generated method stub
				if (!supplyItemForm.validate()) return;
				supplyItemForm.saveData(new DSCallback(){

					@Override
					public void execute(DSResponse response, Object rawData,
							DSRequest request) {
						// TODO Auto-generated method stub
						Record[] rec = response.getData();
						if (rec[0].getAttributeAsString("unitCost") == null) {
							SC.say("Server rejected attempt to change 'unitCost' field by non-Admin user as expected");
						}
					}
				});
			}
        });

        final TabSet theTabs = new TabSet();  
		theTabs.setWidth(750);  
		theTabs.setHeight(600);  
		final Tab tabRoles = new Tab("Roles");
		final Tab tabItems = new Tab("Supply Item");
		
        tabRoles.setPane(hLayout);
        
        VLayout vLayout = new VLayout();
        vLayout.setMargin(20);
        vLayout.addMember(supplyItemForm);
        vLayout.addMember(saveButton);
        vLayout.addMember(supplyItemGrid);

        tabItems.setPane(vLayout);
        
	    canvas.addChild(theTabs);
	    canvas.draw();
	    
		windowRelogin = new Window();
		windowRelogin.setAutoCenter(true);
		windowRelogin.setTitle("Relogin");
		windowRelogin.setShowCloseButton(false);
		windowRelogin.setShowMinimizeButton(false);
		windowRelogin.setShowMaximizeButton(false);
		windowRelogin.setWidth(340);
		windowRelogin.setIsModal(true);
		windowRelogin.setShowModalMask(true);
		windowRelogin.setHeight(130);

		final DynamicForm formLogin = new DynamicForm();
	    formLogin.setAlign(Alignment.CENTER);
	    formLogin.setGroupTitle("Data for Log in");
	    formLogin.setIsGroup(false);
	    
	    TextItem login = new TextItem();
	    login.setTitle("Username");
	    login.setName("j_username");
	    login.setRequired(true);
	    
	    PasswordItem password = new PasswordItem();  
	    password.setTitle("Password");
	    password.setName("j_password");
	    password.setRequired(true);

	    ButtonItem button = new ButtonItem();
	    button.setTitle("Log In");
	    button.setWidth(100);
	    button.addClickHandler(new com.smartgwt.client.widgets.form.fields.events.ClickHandler() {

				@Override
				public void onClick(
						com.smartgwt.client.widgets.form.fields.events.ClickEvent event) {
					// TODO Auto-generated method stub
	            	if (!formLogin.validate()) return;
	            	
                    // we have seen some installations of JDBC Realms where this request is 
                    // required or the system would not accept credentials submitted by the relogin form.
                    RPCManager.startQueue();
	            	RPCRequest request = new RPCRequest();
	       	     	request.setActionURL("loginSuccessMarker.html");
	       	     	RPCManager.sendRequest(request);
                    lsmTransactionNum = RPCManager.getQueueTransactionId();
                    RPCManager.sendQueue();
	            	
	            	validateLogin(formLogin.getValueAsString("j_username"), formLogin.getValueAsString("j_password"));					
				}
	    }); 
	    formLogin.setFields(login,password,button);
	    windowRelogin.addItem(formLogin);
	    
		// setup Relogin
	    RPCManager.setLoginRequiredCallback(new LoginRequiredCallback(){

			@Override
			public void loginRequired(int transactionNum, RPCRequest request,
					RPCResponse response) {
				// TODO Auto-generated method stub
				if ((!windowRelogin.isDrawn()) || (!windowRelogin.isVisible())) {
					formLogin.clearValues();
					formLogin.focusInItem("j_username");
				    windowRelogin.redraw();
				    windowRelogin.show();
				}
			}
        });
	    
	    RPCRequest request = new RPCRequest();
	    request.setActionURL("ServletLogin");
	    RPCManager.sendRequest(request,new RPCCallback(){
	         public void execute(RPCResponse response, Object rawData, RPCRequest request) {
	        	 User.setRoles(rawData.toString());
       			 if (User.hasRole("admin")) {
	        		theTabs.addTab(tabRoles);
	        	 	theTabs.addTab(tabItems);
	        	 } else {
	        		 theTabs.addTab(tabItems);
	        	 }
	         }
	     });
	}  
	
	public void validateLogin(String j_username, String j_password){
		 RPCRequest request = new RPCRequest();
	     request.setContainsCredentials(true);
	     request.setActionURL("j_security_check");
	     request.setUseSimpleHttp(true);
	     request.setShowPrompt(false);
	     Map params = new HashMap();
	     params.put("j_username",j_username);
	     params.put("j_password",j_password);
	     request.setParams(params);
	     RPCManager.sendRequest(request,new RPCCallback(){
	         public void execute(RPCResponse response, Object rawData, RPCRequest request) {
	        	 String data = String.valueOf(rawData);
	        	 if (data.contains("Invalid")) {
	            	 SC.warn("Invalid username and/or password, please try again");
	             } else {
                     if (lsmTransactionNum > 0) RPCManager.clearTransaction(lsmTransactionNum);
	            	 RPCManager.resendTransaction();
	                 windowRelogin.hide();
	             }
	         }
	     });
    }
	
	/** 
     * Float values should be formatted into human-readable text 
     *  
     * @return 
     */  
    private CellFormatter getFloatValuesFormatter() {  
        return new CellFormatter() {  
            @Override  
            public String format(Object value, ListGridRecord record, int rowNum, int colNum) {  
                if (value == null)  
                    return null;  
  
                if (value instanceof Float) {  
                    NumberFormat nf = NumberFormat.getFormat("0.00");  
                    try {  
                        return nf.format(((Number) value).floatValue());  
                    } catch (Exception e) {  
                        return value.toString();  
                    }  
                }  
                return String.valueOf(value);  
            }  
        };  
    }  
}
