package com.smartgwt.sample.server;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.isomorphic.datasource.BasicDataSource;
import com.isomorphic.datasource.DSRequest;
import com.isomorphic.datasource.DSResponse;

public class UsersRolesDataSource extends BasicDataSource {  
	  

    public DSResponse executeFetch(DSRequest req) throws Exception {  
        DSResponse resp = new DSResponse();
        resp.setData(fetchUsersRolesAll(req, resp));
        resp.setStatus(0);
        return resp;  
    }  
    
    public DSResponse executeAdd(DSRequest req) throws Exception {  
        DSResponse resp = new DSResponse();  
        resp.setData(createRecord(req.getValues()));  
        resp.setStatus(0);  
        return resp;  
    }
    
    public DSResponse executeRemove(DSRequest req) throws Exception {
    	DSResponse resp = new DSResponse();  
        resp.setData(removeRecord(req.getValues()));  
        resp.setStatus(0);  
        return resp;  
    }
  
// -----------------------------------------------------------------------------------------  
// You can replace code below to implement any data access approah you actually want to use.  
// -----------------------------------------------------------------------------------------  
  
    private List fetchUsersRolesAll (DSRequest req, DSResponse resp) throws Exception {  
    	List collection = new ArrayList();
    	ResultSet rest = null;
    	Map criteria = req.getCriteria();
    	Connection conn = DBConnection.getConnection();
    	String query = "select user_name, role_name from isg_users_roles where user_name = '"+criteria.get("userName").toString()+"'";
    	rest = (conn.prepareStatement(query)).executeQuery();
        if (rest != null)
        {
        	while (rest.next())
        	{
        		Map record = new HashMap();
        		record.put("userName", rest.getString(1));
        		record.put("roleName", rest.getString(2));
        		collection.add(record);
        	}
        	rest.close();
        }
   	    conn.close();
		return collection;
    }
    
    private Map createRecord(Map values) throws Exception {  
    	List collection = new ArrayList();
    	Connection conn = DBConnection.getConnection();
    	String query = "insert into isg_users_roles values(?,?)";
    	PreparedStatement statment = conn.prepareStatement(query);
    	statment.setString(1, values.get("userName").toString());
    	statment.setString(2, values.get("roleName").toString());
    	statment.executeUpdate();
    	statment.close();
   	    conn.close();
		return values;
    }  
    
    private Map removeRecord(Map values) throws Exception {  
    	List collection = new ArrayList();
    	Connection conn = DBConnection.getConnection();
    	String query = "delete from isg_users_roles where user_name = ? and role_name = ?";
    	PreparedStatement statment = conn.prepareStatement(query);
    	statment.setString(1, values.get("userName").toString());
    	statment.setString(2, values.get("roleName").toString());
    	statment.executeUpdate();
    	statment.close();
   	    conn.close();
		return values;
    }
}